%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            Michael Pokojovy                             % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1);

set(gcf, 'PaperUnits', 'centimeters');
xSize = 20; ySize = 14;
xLeft = (21 - xSize)/2; yTop = (30 - ySize)/2;
set(gcf,'PaperPosition', [xLeft yTop xSize ySize]);
set(gcf,'Position',[0 0 xSize*50 ySize*50]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t = title('Stereographische Projektion', 'interpreter', 'latex');
set(t, 'FontSize', 16);

axis([-3 3 -3 3 -1 1]);

xlabel('x');
ylabel('y');
zlabel('z');

grid on;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hold on;

theta = linspace(-pi/2, pi/2, 100);
phi = linspace(0, 2*pi, 16);

for i = 1:length(phi)
    x = cos(phi(i))*cos(theta);
    y = sin(phi(i))*cos(theta);
    z = sin(theta);
    
    plot3(x, y, z, 'b--');
end

theta = linspace(-pi/2, pi/2, 10);
phi = linspace(0, 2*pi, 100);

for i = 1:length(theta)
    x = cos(phi)*cos(theta(i));
    y = sin(phi)*cos(theta(i));
    z = sin(theta(i))*ones(size(phi));
    
    plot3(x, y, z, 'b--');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theta = [0.9 0.5 -1];
phi   = [1 2.6 1.5];

Phi = linspace(0, 2*pi, 100);

x = cos(phi).*cos(theta);
y = sin(phi).*cos(theta);
z = sin(theta);

X = x./(1 - z);
Y = y./(1 - z);

for i = 1:length(theta)
    plot3([0 X(i)], [0 Y(i)], [1 0], 'k');
    plot3([0 x(i)], [0 y(i)], [1 z(i)], 'k');
    
    xl = cos(Phi)*cos(theta(i));
    yl = sin(Phi)*cos(theta(i));
    zl = sin(theta(i))*ones(size(Phi));
    
    Xl = xl./(1 - zl);
    Yl = yl./(1 - zl);
    Zl = zeros(size(Phi));
    
    plot3(xl, yl, zl, 'g');
    plot3(Xl, Yl, Zl, 'r');
    
    plot3(x(i), y(i), z(i), 'g*');
    plot3(X(i), Y(i), 0, 'r*');
end
    
view([-85 60]);